#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <unistd.h>


int main( int argc, char** argv )
{
    int sockfd;
    struct sockaddr_in server;
    struct hostent *hp;

    if( argc != 4 ) {
        printf( "usage: %s host port message\n", argv[ 0 ] );
        exit( EXIT_FAILURE );
    }

    memset( &server, 0x0, sizeof( struct sockaddr_in ) );
    server.sin_family = AF_INET;
    server.sin_port = htons( atoi( argv[ 2 ] ) );

    hp = gethostbyname( argv[ 1 ] );
    if( hp == NULL) {
        printf("unknown server!\n");
        exit( EXIT_FAILURE );
    }

    memcpy( &server.sin_addr, hp->h_addr, sizeof( server.sin_addr ) );


    if( ( sockfd = socket( AF_INET, SOCK_DGRAM, 0) ) < 0 ) {
        perror("socket() error");
        exit( EXIT_FAILURE );
    }

    size_t msglen = strlen( argv[ 3 ] );

    if( sendto( sockfd, argv[ 3 ], msglen, 0, ( struct sockaddr*) &server, sizeof( struct sockaddr ) ) < 0) {
        perror("sendto() error");
        close( sockfd );
        exit( EXIT_FAILURE );
    }
    close( sockfd );
    exit( EXIT_SUCCESS );
}
